#
# SPEC-cpu.R,  7 Feb 14
#
# Date from:
# www.spec.org/cpu2006/results

source("config.r")


cpu2006=read.csv(paste0(root, "benchmark/cpu2006-results-20140206.csv"), as.is=TRUE)
mem2006=read.csv(paste0(root, "benchmark/cpu2006-memory.csv"), as.is=TRUE)

cpu2006=cbind(cpu2006, mem2006)
cpu2006$Test.Date=as.Date(paste0("01-", cpu2006$Test.Date), format="%d-%B-%Y")
start_date=as.Date("01-Jan-2006", format="%d-%B-%Y")
cpu2006=subset(cpu2006, Test.Date >= start_date)

cint=subset(cpu2006, Benchmark == "CINT2006")
cint$Benchmark=NULL
cint=subset(cint, Result > 0)


plot(cint$Test.Date, cint$Result,
	xlab="Measurement date", ylab="SPEC2006 int")
plot(cint$Processor.MHz, cint$Result,
	xlab="Processor speed MHz", ylab="SPEC2006 int")

PC2=subset(cint, mem_kind == "PC2")
PC3=subset(cint, mem_kind != "PC2")

xbounds=range(cint$mem_rate)
ybounds=range(cint$Result)
plot(PC2$mem_rate, PC2$Result, col="blue",
	xlim=c(0, 15000), ylim=ybounds,
	xlab="Memory rate", ylab="SPEC2006 int")
par(new=TRUE)
plot(PC3$mem_rate, PC3$Result, col="red",
	xlim=c(0, 15000), ylim=ybounds,
	xlab="", ylab="")

brew_col=brewer.pal(3, "Dark2")

c_mod=glm(Result ~ ., data=cint)

c_mod=glm(Result ~ Baseline + X..Cores + X..Chips. + 
    X..Cores.Per.Chip. + X..Threads.Per.Core + Processor. + Processor.MHz + 
    CPU.s..Orderable + Auto.Parallelization + 
    Base.Pointer.Size + Peak.Pointer.Size + X1st.Level.Cache + 
    X2nd.Level.Cache + X3rd.Level.Cache + Other.Cache + Memory + 
    Compiler +
    Test.Date, data=cint)

# Baseline               33427   1  < 2.2e-16 ***
# X..Cores                   1   1  0.2220513    
# X..Chips.                 19   1  1.647e-05 ***
# X..Threads.Per.Core        9   1  0.0021080 ** 
# Processor.              4725 502  < 2.2e-16 ***
# Processor.MHz              5   1  0.0314029 *  
# CPU.s..Orderable          37  24  0.0396780 *  
# Peak.Pointer.Size         18   2  0.0001005 ***
# Memory                  1340 570  < 2.2e-16 ***
# Compiler                3699 117  < 2.2e-16 ***
# Test.Date                  6   1  0.0121510 *  

